#
# color3.rb
#
# $Id: color3.rb,v 1.1 2000/11/21 03:15:37 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


nx = 21
ny = 21
xmin = -10
xmax = 10
ymin = -10
ymax = 10
dx1 = 1
dx2 = 5
dy1 = 1
dy2 = 5
kmax = 56
pmin = 0
pmax = 1
p = NArray.sfloat(nx, ny)
pi = NArray.sfloat(2, kmax+1)

#-- data ---
for j in 0..ny-1
  for i in 0..nx-1
    x = xmin + (xmax-xmin)*i/(nx-1).to_f
    y = ymin + (ymax-ymin)*j/(ny-1).to_f
    p[i,j] = exp(-x**2/64 -y**2/25)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

dp = (pmax-pmin)/kmax.to_f
for k in 1..kmax
  tlev1 = (k-1)*dp
  tlev2 = tlev1 + dp
  ipat  = (29+k)*1000 + 999
  uestlv(tlev1, tlev2, ipat)
end

uetone(p, nx, nx, ny)
usdaxs

#-- ȡС ----
grswnd(0.0, 1.0, pmin, pmax)
grsvpt(0.85, 0.9, 0.2, 0.8)
grstrn(1)
grstrf

for k in 0..kmax
  pi[0,k] = pmin + k*dp
  pi[1,k] = pmin + k*dp
end

uetone(pi, 2, 2, kmax+1)

slpvpr(3)
uzlset('LABELYR', true)

uzfact(0.8)
uysfmt('(F4.1)')
uyaxdv('R', 0.1, 0.2)

grcls

